//Script and model made by Fastmapler.
//setmodpaths(getmodpaths()); exec("Add-Ons/Weapon_BFG10k/server.cs"); transmitdatablocks();

%error = ForceRequiredAddOn("Weapon_Gun");
if(%error == $Error::AddOn_Disabled)
{
	error("Weapon_BFG10k - Weapon_Gun required. Enabling + removing UI name.");
	gunItem.uiName = "";
}
else if (%error == $Error::AddOn_NotFound)
{
	error("Weapon_BFG10k - Weapon_Gun not found. Why don't you have this?!?!");
	return;
}

%error2 = ForceRequiredAddOn("Weapon_Rocket_Launcher");
if(%error2 == $Error::AddOn_Disabled)
{
	error("Weapon_BFG10k - Weapon_Rocket_Launcher required. Enabling + removing UI name.");
	rocketLauncherItem.uiName = "";
}
else if (%error2 == $Error::AddOn_NotFound)
{
	error("Weapon_BFG10k - Weapon_Rocket_Launcher not found. Are your mod paths set up properly?");
	return;
}

// ## Sounds ##

datablock AudioProfile(BFG10kSoundWarmup)
{
   filename    = "Add-Ons/Weapon_BFG10k/BFG10k Warmup.wav";
   description = AudioClose3d;
   preload     = true;
};

datablock AudioProfile(BFG10kSoundFire)
{
   filename    = "Add-Ons/Weapon_BFG10k/BFG10k Fire.wav";
   description = AudioClose3d;
   preload     = true;
};

datablock AudioProfile(BFG10kSoundCooldown)
{
   filename    = "Add-Ons/Weapon_BFG10k/BFG10k Cooldown.wav";
   description = AudioClose3d;
   preload     = true;
};

datablock AudioProfile(BFG10kSoundExplode)
{
   filename    = "Add-Ons/Weapon_BFG10k/BFG10k Explode.wav";
   description = AudioClose3d;
   preload     = true;
};

// ## Particle Data ##

datablock ParticleData(BFG10kExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 250;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.0 0.9 0.0 0.9";
	colors[1]     = "0.0 1.0 0.0 0.0";
	sizes[0]      = 5.0;
	sizes[1]      = 0.0;

	useInvAlpha = true;
};

datablock ParticleEmitterData(BFG10kExplosionEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 5.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BFG10kExplosionParticle";

   uiName = "BFG10k Explosion Smoke";
   emitterNode = TenthEmitterNode;
};


datablock ParticleData(BFG10kExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 1.0 1.0 0.5";
	colors[1]     = "0.0 0.0 0.0 0.0";
	sizes[0]      = 8;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BFG10kExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BFG10kExplosionRingParticle";

   uiName = "BFG10k Explosion Flash";
};

datablock ExplosionData(BFG10kExplosion)
{
	explosionShape = "Add-Ons/Weapon_BFG10k/BFG10kExplosion.dts";
	soundProfile = BFG10kSoundExplode;
	
	lifeTimeMS = 350;

	particleEmitter = BFG10kExplosionEmitter;
	particleDensity = 7;
	particleRadius = 0.2;

	emitter[0] = BFG10kExplosionRingEmitter;

	faceViewer     = true;
	explosionScale = ".33 .33 .33";

	shakeCamera = true;
	camShakeFreq = "6.6 7.3 6.6";
	camShakeAmp = "2.0 6.6 2.0";
	camShakeDuration = 0.33;
	camShakeRadius = 14.0;

	// Dynamic light
	lightStartRadius = 10;
	lightEndRadius = 25;
	lightStartColor = "0 1 0 1";
	lightEndColor = "0 0 0 1";

	damageRadius = 3;
	radiusDamage = 45;

	impulseRadius = 4;
	impulseForce = 1500;
   
	uiName = "BFG10k Explosion";
};

datablock ParticleData(BFG10kFireFlashParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.2;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/ring";
	spinSpeed			= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0.0 1.0 0.0 0.5";
	colors[1]     = "1.0 1.0 1.0 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};

datablock ParticleEmitterData(BFG10kFireFlashEmitter)
{
	lifeTimeMS = 200;

   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 360;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BFG10kFireFlashParticle";

   uiName = "";
};

datablock ParticleData(BFG10kWarmupParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = -1.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed			= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0.0 1.0 0.0 0.5";
	colors[1]     = "1.0 1.0 1.0 0.5";
	sizes[0]      = 0.3;
	sizes[1]      = 0.6;

	useInvAlpha = false;
};

datablock ParticleEmitterData(BFG10kWarmupEmitter)
{
	lifeTimeMS = 800;

   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = -10;
   velocityVariance = 0.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 360;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BFG10kWarmupParticle";

   uiName = "";
};

datablock ParticleData(BFG10kTrailParticle)
{
	textureName          = "base/data/particles/ring";
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.1;
	windCoefficient      = 0;
	constantAcceleration = 0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 250;
	spinSpeed     = 0;
	spinRandomMin = -90.0;
	spinRandomMax =  90.0;
	useInvAlpha   = false;

	colors[0]	= "0.0 1.0 0.0 1.0";
	colors[1]	= "1.0 1.0 1.0 0.0";

	sizes[0]	= 0.7;
	sizes[1]	= 0.1;

	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(BFG10kTrailEmitter)
{
   ejectionPeriodMS = 6;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   ejectionOffset   = 0.0;
   velocityVariance = 0.0;
   thetaMin         = 45;
   thetaMax         = 90;
   phiReferenceVel  = 45;
   phiVariance      = 5;
   overrideAdvance = false;
   
   particles = BFG10kTrailParticle;   

   useEmitterColors = true;

	uiName = "BFG10k Trail";
};

// ## Weapon Data ##

AddDamageType("BFG10kDirect", '<bitmap:Add-Ons/Weapon_BFG10k/CI_BFG10k> %1', '%2 <bitmap:Add-Ons/Weapon_BFG10k/CI_BFG10k> %1',0.2,1);
AddDamageType("BFG10kRadius", '( <bitmap:Add-Ons/Weapon_BFG10k/CI_BFG10k> ) %1', '%2 ( <bitmap:Add-Ons/Weapon_BFG10k/CI_BFG10k> ) %1',0.2,1);

datablock ProjectileData(BFG10kProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts"; //TODO - Get a new projectile
   directDamage        = 0; //lol no damage
   directDamageType	= $DamageType::BFG10kDirect;
   radiusDamageType = $DamageType::BFG10kRadius;
   impactImpulse	   = 650;
   verticalImpulse	   = 650;
   explosion           = BFG10kExplosion;
   particleEmitter     = BFG10kTrailEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 20;             
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 40;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   //sound = rocketLoopSound;

   muzzleVelocity      = 150;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.0 1.0 0.0";

   uiName = "BFG10k Plasma Ball";
};

datablock ItemData(BFG10kItem : GunItem)
{
	shapeFile       = "Add-Ons/Weapon_BFG10k/BFG10k.dts";
	uiName          = "BFG10k";
	iconName        = "Add-Ons/Weapon_BFG10k/Icon_BFG10k";
	doColorShift    = false;
	colorShiftColor = "0.50 0.75 0.50 0.75";
	image			= BFG10kImage;
};

datablock ShapeBaseImageData(BFG10kImage)
{
	// Basic Item properties
	shapeFile  = "Add-Ons/Weapon_BFG10k/BFG10k.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile && Ammo.
	item = BFG10kItem;
	ammo = " ";
	projectile = BFG10kProjectile;
	projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

	//melee particles shoot from eye node for consistancy
	melee = false;
	//raise your arm up or not
	armReady = true;

	doColorShift    = BFG10kItem.doColorShift;
	colorShiftColor = BFG10kItem.colorShiftColor;

	stateName[0]					= "Activate"; //When item taken out
	stateTimeoutValue[0]			= 0.15;
	stateTransitionOnTimeout[0]		= "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]					= "Ready"; //Ready to fire
	stateTransitionOnTriggerDown[1]	= "Warmup";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
   
	stateName[2]					= "Warmup"; //Warmup delay
	stateTimeoutValue[2]			= 0.8;
	stateTransitionOnTimeout[2]		= "Fire";
	stateAllowImageChange[2]		= false;
	stateEmitter[2]					= BFG10kWarmupEmitter;
	stateEmitterTime[2]				= 0.8;
	stateSound[2]					= BFG10kSoundWarmup;
	stateScript[2]					= "onWarmup";

	stateName[3]					= "Fire"; //Fire projectile
	stateTimeoutValue[3]			= 0.17;
	stateTransitionOnTimeout[3]		= "Reload";
	stateFire[3]					= true;
	stateAllowImageChange[3]		= false;
	stateScript[3]					= "onFire";
	stateEmitter[3]					= BFG10kFireFlashEmitter;
	stateEmitterTime[3]				= 0.1;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= BFG10kSoundFire;
	stateEjectShell[3]				= false;
	stateSequence[3]				= "Fire";
   
	stateName[4]					= "Reload"; //Check if mousefire is held
	stateTransitionOnNoAmmo[4]		= "Smoke";
	stateTransitionOnTriggerUp[4]	= "Smoke";
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateAllowImageChange[4]		= false;
	stateSequence[4]				= "Ready";

	stateName[5]					= "Smoke";
	stateEmitter[5]					= gunSmokeEmitter;
	stateAllowImageChange[5]		= false;
	stateEmitterTime[5]				= 0.5;
	stateEmitterNode[5]				= "muzzleNode";
	stateTimeoutValue[5]			= 1.0;
	stateTransitionOnTimeout[5]		= "Ready";
	stateScript[5]					= "onStopFire";
	stateSound[5]					= BFG10kSoundCooldown;
};

function BFG10kImage::onWarmup(%this, %obj, %slot)
{
	%obj.setImageAmmo(0,1);
}

function BFG10kImage::onMount(%this, %obj, %slot)
{
	if (getSimTime() - %obj.BFG10kLastShot > 1000)
		%obj.BFG10kHeat = 0;
}

// ## Fire Projectile ##

//Ephialtes' bullet spread coding
function BFG10kImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0) return;
	
	%obj.playThread(2, plant);
		
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.getEyeVector(),"-1")));
	//%spread = 0;
	%projectile = %this.projectile;
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	//%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	//%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	//%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	//%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%mat = MatrixCreateFromEuler("0 0 0");
	%velocity = MatrixMulVector(%mat, %velocity);
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	
	%maxShots = 20;
	
	%obj.BFG10kHeat += 1;
	%obj.BFG10kLastShot = getSimTime();
	
	if (%obj.BFG10kHeat >= %maxShots)
	{
		%obj.setImageAmmo(0,0);
		%obj.spawnExplosion("BFG10kProjectile",1);
	}
	
	for (%i = 0; %i < %obj.BFG10kHeat; %i++)
	{
		%print = %print @ "|";
	}
	
	if (%obj.BFG10kHeat < 8) %color = "<color:00ff00>";
	else if (%obj.BFG10kHeat >= 8 && %obj.BFG10kHeat < 15) %color = "<color:ffff00>";
	else { %color = ""; %message = "<br>OVERHEATING!"; }
	
	if (isObject(%obj.client)) %obj.client.bottomPrint(%color @ %print @ %message,1,1);
}

function BFG10kImage::onStopFire(%this, %obj, %slot)
{
	%obj.BFG10kHeat = 0;
}